
/*
 * $Id: ErrorMgr.h,v 1.1.2.2 1999/02/20 02:39:34 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef ERROR_MGR_H
#define ERROR_MGR_H

#include "Array.h"

// central point for all error events
class ErrorMgr {
	public:
		static void Configure(ErrorMgr *aMgr);

	public:
		ErrorMgr(int aMaxErrNo); // defaults
		virtual ~ErrorMgr() {}

		int maxErrNo() const { return theMaxErrNo; }

		virtual void noteError(int e);
		virtual void reportError(int e);

		virtual bool needExpl(int e);

	protected:
		virtual const char *explStr(int e) const;

	protected:
		int theVerbLvl;             // how often to explain errors
		int theMaxErrNo;

		Array<int> theErrCnts;      // error counts
		Array<int> theExplDlines;   // time of next report
		int theTotCnt;              // total number of errors
};

extern void NoteError(int e);    // just silently count it
extern void ReportError(int e);  // count and maybe print a std explanation
extern bool ExplainError(int e); // count and return true if should explain
extern void FatalError(int e);   // count, report, exit

#endif
